Index: uspace/drv/bus/usb/uhci/transfer_list.h
===================================================================
--- uspace/drv/bus/usb/uhci/transfer_list.h	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/drv/bus/usb/uhci/transfer_list.h	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -36,8 +36,7 @@
 
 #include <fibril_synch.h>
-#include <usb/host/batch.h>
 
 #include "hw_struct/queue_head.h"
-
+#include "uhci_batch.h"
 /** Structure maintaining both hw queue and software list
  * of currently executed transfers
@@ -46,5 +45,5 @@
 	/** Guard against multiple add/remove races */
 	fibril_mutex_t guard;
-	/** UHCI hw structure represeting this queue */
+	/** UHCI hw structure representing this queue */
 	qh_t *queue_head;
 	/** Assigned name, for nicer debug output */
@@ -58,5 +57,5 @@
 void transfer_list_set_next(transfer_list_t *instance, transfer_list_t *next);
 void transfer_list_add_batch(
-    transfer_list_t *instance, usb_transfer_batch_t *batch);
+    transfer_list_t *instance, uhci_transfer_batch_t *batch);
 void transfer_list_remove_finished(transfer_list_t *instance, list_t *done);
 void transfer_list_abort_all(transfer_list_t *instance);
Index: uspace/drv/bus/usb/uhci/uhci.c
===================================================================
--- uspace/drv/bus/usb/uhci/uhci.c	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/drv/bus/usb/uhci/uhci.c	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -41,5 +41,4 @@
 
 #include "uhci.h"
-#include "iface.h"
 #include "pci.h"
 
@@ -87,5 +86,5 @@
 /** Operations supported by the HC driver */
 static ddf_dev_ops_t hc_ops = {
-	.interfaces[USBHC_DEV_IFACE] = &hc_iface, /* see iface.h/c */
+	.interfaces[USBHC_DEV_IFACE] = &hcd_iface, /* see iface.h/c */
 };
 /*----------------------------------------------------------------------------*/
@@ -100,6 +99,7 @@
 {
 	assert(fun);
-	usb_device_keeper_t *manager = &dev_to_uhci(fun->dev)->hc.manager;
-	usb_address_t addr = usb_device_keeper_find(manager, handle);
+	usb_device_manager_t *manager =
+	    &dev_to_uhci(fun->dev)->hc.generic.dev_manager;
+	const usb_address_t addr = usb_device_manager_find(manager, handle);
 
 	if (addr < 0) {
@@ -202,5 +202,5 @@
 	CHECK_RET_DEST_FREE_RETURN(ret, "Failed to create UHCI HC function.\n");
 	instance->hc_fun->ops = &hc_ops;
-	instance->hc_fun->driver_data = &instance->hc;
+	instance->hc_fun->driver_data = &instance->hc.generic;
 
 	instance->rh_fun = ddf_fun_create(device, fun_inner, "uhci_rh");
Index: uspace/drv/bus/usb/uhci/uhci_batch.c
===================================================================
--- uspace/drv/bus/usb/uhci/uhci_batch.c	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
+++ uspace/drv/bus/usb/uhci/uhci_batch.c	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -0,0 +1,347 @@
+/*
+ * Copyright (c) 2011 Jan Vesely
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+/** @addtogroup drvusbuhcihc
+ * @{
+ */
+/** @file
+ * @brief UHCI driver USB transfer structure
+ */
+#include <errno.h>
+#include <str_error.h>
+
+#include <usb/usb.h>
+#include <usb/debug.h>
+
+#include "uhci_batch.h"
+#include "transfer_list.h"
+#include "hw_struct/transfer_descriptor.h"
+#include "utils/malloc32.h"
+
+#define DEFAULT_ERROR_COUNT 3
+
+static void uhci_transfer_batch_dispose(uhci_transfer_batch_t *uhci_batch)
+{
+	if (uhci_batch) {
+		usb_transfer_batch_dispose(uhci_batch->usb_batch);
+		free32(uhci_batch->device_buffer);
+		free(uhci_batch);
+	}
+}
+/*----------------------------------------------------------------------------*/
+/** Safely destructs uhci_transfer_batch_t structure
+ *
+ * @param[in] uhci_batch Instance to destroy.
+ */
+void uhci_transfer_batch_call_dispose(uhci_transfer_batch_t *uhci_batch)
+{
+	assert(uhci_batch);
+	assert(uhci_batch->usb_batch);
+	usb_transfer_batch_finish(uhci_batch->usb_batch,
+	    uhci_transfer_batch_data_buffer(uhci_batch),
+	    uhci_batch->usb_batch->buffer_size);
+	uhci_transfer_batch_dispose(uhci_batch);
+}
+/*----------------------------------------------------------------------------*/
+static void (*const batch_setup[])(uhci_transfer_batch_t*, usb_direction_t);
+/*----------------------------------------------------------------------------*/
+/** Allocate memory and initialize internal data structure.
+ *
+ * @param[in] fun DDF function to pass to callback.
+ * @param[in] ep Communication target
+ * @param[in] buffer Data source/destination.
+ * @param[in] buffer_size Size of the buffer.
+ * @param[in] setup_buffer Setup data source (if not NULL)
+ * @param[in] setup_size Size of setup_buffer (should be always 8)
+ * @param[in] func_in function to call on inbound transfer completion
+ * @param[in] func_out function to call on outbound transfer completion
+ * @param[in] arg additional parameter to func_in or func_out
+ * @return Valid pointer if all structures were successfully created,
+ * NULL otherwise.
+ *
+ * Determines the number of needed transfer descriptors (TDs).
+ * Prepares a transport buffer (that is accessible by the hardware).
+ * Initializes parameters needed for the transfer and callback.
+ */
+uhci_transfer_batch_t * uhci_transfer_batch_get(usb_transfer_batch_t *usb_batch)
+{
+	assert((sizeof(td_t) % 16) == 0);
+#define CHECK_NULL_DISPOSE_RETURN(ptr, message...) \
+	if (ptr == NULL) { \
+		usb_log_error(message); \
+		uhci_transfer_batch_dispose(uhci_batch); \
+		return NULL; \
+	} else (void)0
+
+	uhci_transfer_batch_t *uhci_batch =
+	    calloc(1, sizeof(uhci_transfer_batch_t));
+	CHECK_NULL_DISPOSE_RETURN(uhci_batch,
+	    "Failed to allocate UHCI batch.\n");
+	link_initialize(&uhci_batch->link);
+	uhci_batch->td_count =
+	    (usb_batch->buffer_size + usb_batch->ep->max_packet_size - 1)
+	    / usb_batch->ep->max_packet_size;
+	if (usb_batch->ep->transfer_type == USB_TRANSFER_CONTROL) {
+		uhci_batch->td_count += 2;
+	}
+
+	const size_t total_size = (sizeof(td_t) * uhci_batch->td_count)
+	    + sizeof(qh_t) + usb_batch->setup_size + usb_batch->buffer_size;
+	uhci_batch->device_buffer = malloc32(total_size);
+	CHECK_NULL_DISPOSE_RETURN(uhci_batch->device_buffer,
+	    "Failed to allocate UHCI buffer.\n");
+	bzero(uhci_batch->device_buffer, total_size);
+
+	uhci_batch->tds = uhci_batch->device_buffer;
+	uhci_batch->qh =
+	    (uhci_batch->device_buffer + (sizeof(td_t) * uhci_batch->td_count));
+
+	qh_init(uhci_batch->qh);
+	qh_set_element_td(uhci_batch->qh, &uhci_batch->tds[0]);
+
+	void *dest =
+	    uhci_batch->device_buffer + (sizeof(td_t) * uhci_batch->td_count)
+	    + sizeof(qh_t);
+	/* Copy SETUP packet data to the device buffer */
+	memcpy(dest, usb_batch->setup_buffer, usb_batch->setup_size);
+	dest += usb_batch->setup_size;
+	/* Copy generic data unless they are provided by the device */
+	if (usb_batch->ep->direction != USB_DIRECTION_IN) {
+		memcpy(dest, usb_batch->buffer, usb_batch->buffer_size);
+	}
+	uhci_batch->usb_batch = usb_batch;
+	usb_log_debug2("Batch %p " USB_TRANSFER_BATCH_FMT
+	    " memory structures ready.\n", usb_batch,
+	    USB_TRANSFER_BATCH_ARGS(*usb_batch));
+
+	const usb_direction_t dir = usb_transfer_batch_direction(usb_batch);
+
+	assert(batch_setup[usb_batch->ep->transfer_type]);
+	batch_setup[usb_batch->ep->transfer_type](uhci_batch, dir);
+
+	return uhci_batch;
+}
+/*----------------------------------------------------------------------------*/
+/** Check batch TDs for activity.
+ *
+ * @param[in] uhci_batch Batch structure to use.
+ * @return False, if there is an active TD, true otherwise.
+ *
+ * Walk all TDs. Stop with false if there is an active one (it is to be
+ * processed). Stop with true if an error is found. Return true if the last TD
+ * is reached.
+ */
+bool uhci_transfer_batch_is_complete(uhci_transfer_batch_t *uhci_batch)
+{
+	assert(uhci_batch);
+	assert(uhci_batch->usb_batch);
+
+	usb_log_debug2("Batch %p " USB_TRANSFER_BATCH_FMT
+	    " checking %zu transfer(s) for completion.\n",
+	    uhci_batch->usb_batch,
+	    USB_TRANSFER_BATCH_ARGS(*uhci_batch->usb_batch),
+	    uhci_batch->td_count);
+	uhci_batch->usb_batch->transfered_size = 0;
+	size_t i = 0;
+	for (;i < uhci_batch->td_count; ++i) {
+		if (td_is_active(&uhci_batch->tds[i])) {
+			return false;
+		}
+
+		uhci_batch->usb_batch->error = td_status(&uhci_batch->tds[i]);
+		if (uhci_batch->usb_batch->error != EOK) {
+			assert(uhci_batch->usb_batch->ep != NULL);
+
+			usb_log_debug("Batch(%p) found error TD(%zu):%"
+			    PRIx32 ".\n", uhci_batch->usb_batch, i,
+			    uhci_batch->tds[i].status);
+			td_print_status(&uhci_batch->tds[i]);
+
+			endpoint_toggle_set(uhci_batch->usb_batch->ep,
+			    td_toggle(&uhci_batch->tds[i]));
+			if (i > 0)
+				goto substract_ret;
+			return true;
+		}
+
+		uhci_batch->usb_batch->transfered_size
+		    += td_act_size(&uhci_batch->tds[i]);
+		if (td_is_short(&uhci_batch->tds[i]))
+			goto substract_ret;
+	}
+substract_ret:
+	uhci_batch->usb_batch->transfered_size
+	    -= uhci_batch->usb_batch->setup_size;
+	return true;
+}
+/*----------------------------------------------------------------------------*/
+static const usb_packet_id direction_pids[] = {
+	[USB_DIRECTION_IN] = USB_PID_IN,
+	[USB_DIRECTION_OUT] = USB_PID_OUT,
+};
+/*----------------------------------------------------------------------------*/
+/** Prepare generic data transfer
+ *
+ * @param[in] uhci_batch Batch structure to use.
+ * @param[in] dir Communication direction.
+ *
+ * Transactions with alternating toggle bit and supplied pid value.
+ * The last transfer is marked with IOC flag.
+ */
+static void batch_data(uhci_transfer_batch_t *uhci_batch, usb_direction_t dir)
+{
+	assert(uhci_batch);
+	assert(uhci_batch->usb_batch);
+	assert(uhci_batch->usb_batch->ep);
+	assert(dir == USB_DIRECTION_OUT || dir == USB_DIRECTION_IN);
+
+
+	const usb_packet_id pid = direction_pids[dir];
+	const bool low_speed =
+	    uhci_batch->usb_batch->ep->speed == USB_SPEED_LOW;
+	const size_t mps = uhci_batch->usb_batch->ep->max_packet_size;
+	const usb_target_t target = {{
+	    uhci_batch->usb_batch->ep->address,
+	    uhci_batch->usb_batch->ep->endpoint }};
+
+	int toggle = endpoint_toggle_get(uhci_batch->usb_batch->ep);
+	assert(toggle == 0 || toggle == 1);
+
+	size_t td = 0;
+	size_t remain_size = uhci_batch->usb_batch->buffer_size;
+	char *buffer = uhci_transfer_batch_data_buffer(uhci_batch);
+
+	while (remain_size > 0) {
+		const size_t packet_size =
+		    (remain_size < mps) ? remain_size : mps;
+
+		const td_t *next_td = (td + 1 < uhci_batch->td_count)
+		    ? &uhci_batch->tds[td + 1] : NULL;
+
+		assert(td < uhci_batch->td_count);
+		td_init(
+		    &uhci_batch->tds[td], DEFAULT_ERROR_COUNT, packet_size,
+		    toggle, false, low_speed, target, pid, buffer, next_td);
+
+		++td;
+		toggle = 1 - toggle;
+		buffer += packet_size;
+		remain_size -= packet_size;
+	}
+	td_set_ioc(&uhci_batch->tds[td - 1]);
+	endpoint_toggle_set(uhci_batch->usb_batch->ep, toggle);
+	usb_log_debug2(
+	    "Batch %p %s %s " USB_TRANSFER_BATCH_FMT " initialized.\n", \
+	    uhci_batch->usb_batch,
+	    usb_str_transfer_type(uhci_batch->usb_batch->ep->transfer_type),
+	    usb_str_direction(uhci_batch->usb_batch->ep->direction),
+	    USB_TRANSFER_BATCH_ARGS(*uhci_batch->usb_batch));
+}
+/*----------------------------------------------------------------------------*/
+/** Prepare generic control transfer
+ *
+ * @param[in] uhci_batch Batch structure to use.
+ * @param[in] dir Communication direction.
+ *
+ * Setup stage with toggle 0 and USB_PID_SETUP.
+ * Data stage with alternating toggle and pid determined by the communication
+ * direction.
+ * Status stage with toggle 1 and pid determined by the communication direction.
+ * The last transfer is marked with IOC.
+ */
+static void batch_control(uhci_transfer_batch_t *uhci_batch, usb_direction_t dir)
+{
+	assert(uhci_batch);
+	assert(uhci_batch->usb_batch);
+	assert(uhci_batch->usb_batch->ep);
+	assert(dir == USB_DIRECTION_OUT || dir == USB_DIRECTION_IN);
+	assert(uhci_batch->td_count >= 2);
+	static const usb_packet_id status_stage_pids[] = {
+		[USB_DIRECTION_IN] = USB_PID_OUT,
+		[USB_DIRECTION_OUT] = USB_PID_IN,
+	};
+
+	const usb_packet_id data_stage_pid = direction_pids[dir];
+	const usb_packet_id status_stage_pid = status_stage_pids[dir];
+	const bool low_speed =
+	    uhci_batch->usb_batch->ep->speed == USB_SPEED_LOW;
+	const size_t mps = uhci_batch->usb_batch->ep->max_packet_size;
+	const usb_target_t target = {{
+	    uhci_batch->usb_batch->ep->address,
+	    uhci_batch->usb_batch->ep->endpoint }};
+
+	/* setup stage */
+	td_init(
+	    &uhci_batch->tds[0], DEFAULT_ERROR_COUNT,
+	    uhci_batch->usb_batch->setup_size, 0, false,
+	    low_speed, target, USB_PID_SETUP,
+	    uhci_transfer_batch_setup_buffer(uhci_batch), &uhci_batch->tds[1]);
+
+	/* data stage */
+	size_t td = 1;
+	unsigned toggle = 1;
+	size_t remain_size = uhci_batch->usb_batch->buffer_size;
+	char *buffer = uhci_transfer_batch_data_buffer(uhci_batch);
+
+	while (remain_size > 0) {
+		const size_t packet_size =
+		    (remain_size < mps) ? remain_size : mps;
+
+		td_init(
+		    &uhci_batch->tds[td], DEFAULT_ERROR_COUNT, packet_size,
+		    toggle, false, low_speed, target, data_stage_pid,
+		    buffer, &uhci_batch->tds[td + 1]);
+
+		++td;
+		toggle = 1 - toggle;
+		buffer += packet_size;
+		remain_size -= packet_size;
+		assert(td < uhci_batch->td_count);
+	}
+
+	/* status stage */
+	assert(td == uhci_batch->td_count - 1);
+
+	td_init(
+	    &uhci_batch->tds[td], DEFAULT_ERROR_COUNT, 0, 1, false, low_speed,
+	    target, status_stage_pid, NULL, NULL);
+	td_set_ioc(&uhci_batch->tds[td]);
+
+	usb_log_debug2("Control last TD status: %x.\n",
+	    uhci_batch->tds[td].status);
+}
+/*----------------------------------------------------------------------------*/
+static void (*const batch_setup[])(uhci_transfer_batch_t*, usb_direction_t) =
+{
+	[USB_TRANSFER_CONTROL] = batch_control,
+	[USB_TRANSFER_BULK] = batch_data,
+	[USB_TRANSFER_INTERRUPT] = batch_data,
+	[USB_TRANSFER_ISOCHRONOUS] = NULL,
+};
+/**
+ * @}
+ */
Index: uspace/drv/bus/usb/uhci/uhci_batch.h
===================================================================
--- uspace/drv/bus/usb/uhci/uhci_batch.h	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
+++ uspace/drv/bus/usb/uhci/uhci_batch.h	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -0,0 +1,93 @@
+/*
+ * Copyright (c) 2011 Jan Vesely
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+/** @addtogroup drvusbuhcihc
+ * @{
+ */
+/** @file
+ * @brief UHCI driver USB tranfer helper functions
+ */
+#ifndef DRV_UHCI_BATCH_H
+#define DRV_UHCI_BATCH_H
+
+#include <usb/host/usb_transfer_batch.h>
+#include <adt/list.h>
+
+#include "hw_struct/queue_head.h"
+#include "hw_struct/transfer_descriptor.h"
+
+/** UHCI specific data required for USB transfer */
+typedef struct uhci_transfer_batch {
+	/** Queue head
+	 * This QH is used to maintain UHCI schedule structure and the element
+	 * pointer points to the first TD of this batch.
+	 */
+	qh_t *qh;
+	/** List of TDs needed for the transfer */
+	td_t *tds;
+	/** Number of TDs used by the transfer */
+	size_t td_count;
+	/** Data buffer, must be accessible by the UHCI hw */
+	void *device_buffer;
+	/** Generic transfer data */
+	usb_transfer_batch_t *usb_batch;
+	/** List element */
+	link_t link;
+} uhci_transfer_batch_t;
+
+uhci_transfer_batch_t * uhci_transfer_batch_get(usb_transfer_batch_t *batch);
+void uhci_transfer_batch_call_dispose(uhci_transfer_batch_t *uhci_batch);
+bool uhci_transfer_batch_is_complete(uhci_transfer_batch_t *uhci_batch);
+
+static inline void * uhci_transfer_batch_setup_buffer(
+    const uhci_transfer_batch_t *uhci_batch)
+{
+	assert(uhci_batch);
+	assert(uhci_batch->device_buffer);
+	return uhci_batch->device_buffer + sizeof(qh_t) +
+	    uhci_batch->td_count * sizeof(td_t);
+}
+/*----------------------------------------------------------------------------*/
+static inline void * uhci_transfer_batch_data_buffer(
+    const uhci_transfer_batch_t *uhci_batch)
+{
+	assert(uhci_batch);
+	assert(uhci_batch->usb_batch);
+	return uhci_transfer_batch_setup_buffer(uhci_batch) +
+	    uhci_batch->usb_batch->setup_size;
+}
+/*----------------------------------------------------------------------------*/
+static inline uhci_transfer_batch_t *uhci_transfer_batch_from_link(link_t *l)
+{
+	assert(l);
+	return list_get_instance(l, uhci_transfer_batch_t, link);
+}
+
+#endif
+/**
+ * @}
+ */
Index: uspace/drv/bus/usb/uhci/utils/malloc32.h
===================================================================
--- uspace/drv/bus/usb/uhci/utils/malloc32.h	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/drv/bus/usb/uhci/utils/malloc32.h	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -50,5 +50,5 @@
  * @return Physical address if exists, NULL otherwise.
  */
-static inline uintptr_t addr_to_phys(void *addr)
+static inline uintptr_t addr_to_phys(const void *addr)
 {
 	if (addr == NULL)
@@ -102,9 +102,15 @@
 	if (free_address == 0)
 		return NULL;
-	void *ret = as_area_create(free_address, UHCI_REQUIRED_PAGE_SIZE,
+	void *address = as_area_create(free_address, UHCI_REQUIRED_PAGE_SIZE,
 		  AS_AREA_READ | AS_AREA_WRITE);
-	if (ret != free_address)
+	if (address != free_address)
 		return NULL;
-	return ret;
+	return address;
+}
+/*----------------------------------------------------------------------------*/
+static inline void return_page(void *page)
+{
+	if (page)
+		as_area_destroy(page);
 }
 
Index: uspace/drv/bus/usb/vhc/connhost.c
===================================================================
--- uspace/drv/bus/usb/vhc/connhost.c	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/drv/bus/usb/vhc/connhost.c	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -62,6 +62,6 @@
 	VHC_DATA(vhc, fun);
 
-	usb_address_t addr = device_keeper_get_free_address(&vhc->dev_keeper,
-	    USB_SPEED_HIGH);
+	usb_address_t addr = usb_device_manager_get_free_address(
+	    &vhc->dev_manager, USB_SPEED_HIGH);
 	if (addr < 0) {
 		return addr;
@@ -88,5 +88,5 @@
 	usb_log_debug("Binding handle %" PRIun " to address %d.\n",
 	    handle, address);
-	usb_device_keeper_bind(&vhc->dev_keeper, address, handle);
+	usb_device_manager_bind(&vhc->dev_manager, address, handle);
 
 	return EOK;
@@ -105,5 +105,5 @@
 	VHC_DATA(vhc, fun);
 	bool found =
-	    usb_device_keeper_find_by_address(&vhc->dev_keeper, address, handle);
+	    usb_device_manager_find_by_address(&vhc->dev_manager, address, handle);
 	return found ? EOK : ENOENT;
 }
@@ -119,5 +119,5 @@
 	VHC_DATA(vhc, fun);
 	usb_log_debug("Releasing address %d...\n", address);
-	usb_device_keeper_release(&vhc->dev_keeper, address);
+	usb_device_manager_release(&vhc->dev_manager, address);
 
 	return ENOTSUP;
@@ -172,10 +172,4 @@
 	VHC_DATA(vhc, fun);
 
-	endpoint_t *ep = usb_endpoint_manager_get_ep(&vhc->ep_manager,
-	    address, endpoint, direction, NULL);
-	if (ep == NULL) {
-		return ENOENT;
-	}
-
 	int rc = usb_endpoint_manager_unregister_ep(&vhc->ep_manager,
 	    address, endpoint, direction);
@@ -183,5 +177,5 @@
 	return rc;
 }
-
+#if 0
 /** Schedule interrupt out transfer.
  *
@@ -413,4 +407,84 @@
 	return EOK;
 }
+#endif
+static int usb_read(ddf_fun_t *fun, usb_target_t target, uint64_t setup_buffer,
+    uint8_t *data_buffer, size_t data_buffer_size,
+    usbhc_iface_transfer_in_callback_t callback, void *arg)
+{
+	VHC_DATA(vhc, fun);
+
+	endpoint_t *ep = usb_endpoint_manager_get_ep(&vhc->ep_manager,
+	    target.address, target.endpoint, USB_DIRECTION_IN, NULL);
+	if (ep == NULL) {
+		return ENOENT;
+	}
+	const usb_transfer_type_t transfer_type = ep->transfer_type;
+
+
+	vhc_transfer_t *transfer = vhc_transfer_create(target.address,
+	    target.endpoint, USB_DIRECTION_IN, transfer_type,
+	    fun, arg);
+	if (transfer == NULL) {
+		return ENOMEM;
+	}
+	if (transfer_type == USB_TRANSFER_CONTROL) {
+		transfer->setup_buffer = malloc(sizeof(uint64_t));
+		assert(transfer->setup_buffer);
+		memcpy(transfer->setup_buffer, &setup_buffer, sizeof(uint64_t));
+		transfer->setup_buffer_size = sizeof(uint64_t);
+	}
+	transfer->data_buffer = data_buffer;
+	transfer->data_buffer_size = data_buffer_size;
+	transfer->callback_in = callback;
+
+	int rc = vhc_virtdev_add_transfer(vhc, transfer);
+	if (rc != EOK) {
+		free(transfer->setup_buffer);
+		free(transfer);
+		return rc;
+	}
+
+	return EOK;
+}
+
+static int usb_write(ddf_fun_t *fun, usb_target_t target, uint64_t setup_buffer,
+    const uint8_t *data_buffer, size_t data_buffer_size,
+    usbhc_iface_transfer_out_callback_t callback, void *arg)
+{
+	VHC_DATA(vhc, fun);
+
+	endpoint_t *ep = usb_endpoint_manager_get_ep(&vhc->ep_manager,
+	    target.address, target.endpoint, USB_DIRECTION_OUT, NULL);
+	if (ep == NULL) {
+		return ENOENT;
+	}
+	const usb_transfer_type_t transfer_type = ep->transfer_type;
+
+
+	vhc_transfer_t *transfer = vhc_transfer_create(target.address,
+	    target.endpoint, USB_DIRECTION_OUT, transfer_type,
+	    fun, arg);
+	if (transfer == NULL) {
+		return ENOMEM;
+	}
+	if (transfer_type == USB_TRANSFER_CONTROL) {
+		transfer->setup_buffer = malloc(sizeof(uint64_t));
+		assert(transfer->setup_buffer);
+		memcpy(transfer->setup_buffer, &setup_buffer, sizeof(uint64_t));
+		transfer->setup_buffer_size = sizeof(uint64_t);
+	}
+	transfer->data_buffer = (void*)data_buffer;
+	transfer->data_buffer_size = data_buffer_size;
+	transfer->callback_out = callback;
+
+	int rc = vhc_virtdev_add_transfer(vhc, transfer);
+	if (rc != EOK) {
+		free(transfer->setup_buffer);
+		free(transfer);
+		return rc;
+	}
+
+	return EOK;
+}
 
 static int tell_address(ddf_fun_t *fun, devman_handle_t handle,
@@ -442,5 +516,5 @@
 
 	usb_log_debug("tell_address_rh(handle=%" PRIun ")\n", handle);
-	usb_address_t addr = usb_device_keeper_find(&vhc->dev_keeper, handle);
+	usb_address_t addr = usb_device_manager_find(&vhc->dev_manager, handle);
 	if (addr < 0) {
 		return addr;
@@ -460,12 +534,6 @@
 	.unregister_endpoint = unregister_endpoint,
 
-	.interrupt_out = interrupt_out,
-	.interrupt_in = interrupt_in,
-
-	.bulk_in = bulk_in,
-	.bulk_out = bulk_out,
-
-	.control_write = control_write,
-	.control_read = control_read
+	.write = usb_write,
+	.read = usb_read,
 };
 
Index: uspace/drv/bus/usb/vhc/main.c
===================================================================
--- uspace/drv/bus/usb/vhc/main.c	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/drv/bus/usb/vhc/main.c	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -73,5 +73,6 @@
 	}
 	data->magic = 0xDEADBEEF;
-	rc = usb_endpoint_manager_init(&data->ep_manager, (size_t) -1);
+	rc = usb_endpoint_manager_init(&data->ep_manager, (size_t) -1,
+	    bandwidth_count_usb11);
 	if (rc != EOK) {
 		usb_log_fatal("Failed to initialize endpoint manager.\n");
@@ -79,5 +80,5 @@
 		return rc;
 	}
-	usb_device_keeper_init(&data->dev_keeper);
+	usb_device_manager_init(&data->dev_manager);
 
 	ddf_fun_t *hc = ddf_fun_create(dev, fun_exposed, "hc");
Index: uspace/drv/bus/usb/vhc/vhcd.h
===================================================================
--- uspace/drv/bus/usb/vhc/vhcd.h	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/drv/bus/usb/vhc/vhcd.h	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -39,5 +39,5 @@
 #include <usbvirt/device.h>
 #include <usb/host/usb_endpoint_manager.h>
-#include <usb/host/device_keeper.h>
+#include <usb/host/usb_device_manager.h>
 #include <usbhc_iface.h>
 #include <async.h>
@@ -60,5 +60,5 @@
 	fibril_mutex_t guard;
 	usb_endpoint_manager_t ep_manager;
-	usb_device_keeper_t dev_keeper;
+	usb_device_manager_t dev_manager;
 	usbvirt_device_t *hub;
 	ddf_fun_t *hc_fun;
Index: uspace/drv/char/ns8250/ns8250.c
===================================================================
--- uspace/drv/char/ns8250/ns8250.c	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/drv/char/ns8250/ns8250.c	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -59,5 +59,8 @@
 
 #include <devman.h>
+#include <ns.h>
 #include <ipc/devman.h>
+#include <ipc/services.h>
+#include <ipc/irc.h>
 #include <device/hw_res.h>
 #include <ipc/serial_ctl.h>
@@ -409,4 +412,22 @@
 static int ns8250_interrupt_enable(ns8250_t *ns)
 {
+	/*
+	 * Enable interrupt using IRC service.
+	 * TODO: This is a temporary solution until the device framework
+	 * takes care of this itself.
+	 */
+	async_sess_t *irc_sess = service_connect_blocking(EXCHANGE_SERIALIZE,
+	    SERVICE_IRC, 0, 0);
+	if (!irc_sess) {
+		return EIO;
+	}
+
+	async_exch_t *exch = async_exchange_begin(irc_sess);
+	if (!exch) {
+		return EIO;
+	}
+	async_msg_1(exch, IRC_ENABLE_INTERRUPT, ns->irq);
+	async_exchange_end(exch);
+
 	/* Enable interrupt on the serial port. */
 	ns8250_port_interrupts_enable(ns->port);
Index: uspace/lib/c/Makefile
===================================================================
--- uspace/lib/c/Makefile	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/lib/c/Makefile	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -63,4 +63,5 @@
 	generic/as.c \
 	generic/cap.c \
+	generic/cfg.c \
 	generic/clipboard.c \
 	generic/devman.c \
Index: uspace/lib/c/generic/adt/hash_table.c
===================================================================
--- uspace/lib/c/generic/adt/hash_table.c	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/lib/c/generic/adt/hash_table.c	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -152,6 +152,4 @@
 	
 	if (keys == h->max_keys) {
-		link_t *cur;
-		
 		/*
 		 * All keys are known, hash_table_find() can be used to find the
@@ -159,5 +157,5 @@
 		 */
 		
-		cur = hash_table_find(h, key);
+		link_t *cur = hash_table_find(h, key);
 		if (cur) {
 			list_remove(cur);
@@ -174,7 +172,6 @@
 	hash_index_t chain;
 	for (chain = 0; chain < h->entries; chain++) {
-		link_t *cur;
-		
-		for (cur = h->entry[chain].head.next; cur != &h->entry[chain].head;
+		for (link_t *cur = h->entry[chain].head.next;
+		    cur != &h->entry[chain].head;
 		    cur = cur->next) {
 			if (h->op->compare(key, keys, cur)) {
Index: uspace/lib/c/generic/as.c
===================================================================
--- uspace/lib/c/generic/as.c	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/lib/c/generic/as.c	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -123,5 +123,5 @@
  * @retval ENOENT Mapping not found.
  */
-int as_get_physical_mapping(void *address, uintptr_t *frame)
+int as_get_physical_mapping(const void *address, uintptr_t *frame)
 {
 	uintptr_t tmp_frame;
